﻿// Keep these lines for a best effort IntelliSense of Visual Studio 2017 and higher.
/// <reference path="./../../Packages/Beckhoff.TwinCAT.HMI.Framework.12.752.0/runtimes/native1.12-tchmi/TcHmi.d.ts" />
(function (/** @type {globalThis.TcHmi} */ TcHmi) {
    var Functions;
    (function (/** @type {globalThis.TcHmi.Functions} */ Functions) {
        var Popup_DataBackAndForth;
        (function (Popup_DataBackAndForth) {
            function OpenPopup(ImageSource, PopupName, OpeningPopup, WhereToInsert, RealValue, Alarm, Angle) {
                var popupParametersControl = [];
                var PopupUuid = String("Popup_" + TcHmiEx.Utilities.generateUuidv4());
                var popup;
                var popupType = OpeningPopup.split(".");
                console.log("Control found 2");
                popupType = popupType[popupType.length - 1].toLowerCase();
                popupParametersControl['data-tchmi-left'] = TcHmiEx.Utilities.ClickCoordinates.x;
                popupParametersControl['data-tchmi-top'] = TcHmiEx.Utilities.ClickCoordinates.y;
                popupParametersControl['data-tchmi-height'] = 200;
                popupParametersControl['data-tchmi-width'] = 370;
                popupParametersControl['data-tchmi-zindex'] = "1000";
                popupParametersControl['data-tchmi-name'] = PopupName;
                popupParametersControl['data-tchmi-imagepath'] = ImageSource;   


                var myControl = TcHmi.Controls.get('PLCDataDisplay_UserControl_1');
                if (myControl) {
                    var symbolRealParameter = TcHmi.Binding.resolveEx('someRealParameter', myControl); // note that someRealParameter != SomeRealParameter
                    if (symbolRealParameter) {
                        popupParametersControl['data-tchmi-realvalue'] = symbolRealParameter.toString();
                    }
                    var symbolIntParameter = TcHmi.Binding.resolveEx('someIntParameter', myControl); 
                    if (symbolIntParameter) {
                        popupParametersControl['data-tchmi-angle'] = symbolIntParameter.toString();
                    }
                    var myAlarm = TcHmi.Binding.resolveEx('alarm', myControl);
                    if (myAlarm) {
                        popupParametersControl['data-tchmi-alarm'] = myAlarm.toString();
                    }
                }

                if (WhereToInsert == undefined) { WhereToInsert = "Desktop" }
                if (popupType == "usercontrol") {
                    popupParametersControl['data-tchmi-target-user-control'] = OpeningPopup;
                    popup = TcHmi.ControlFactory.createEx(
                        'tchmi-user-control-host',
                        PopupUuid,
                        popupParametersControl
                    );
                }
                var desktop = TcHmi.Controls.get(WhereToInsert.__id);
                if (desktop && popup) {
                    desktop.addChild(popup);
                    TcHmiEx.Utilities.dragElement(document.getElementById(PopupUuid));
                }
                return;

            }
            Popup_DataBackAndForth.OpenPopup = OpenPopup;
        })(Popup_DataBackAndForth = Functions.Popup_DataBackAndForth || (Functions.Popup_DataBackAndForth = {}));
        Functions.registerFunctionEx('OpenPopup', 'TcHmi.Functions.Popup_DataBackAndForth', Popup_DataBackAndForth.OpenPopup);
    })(Functions = TcHmi.Functions || (TcHmi.Functions = {}));
})(TcHmi);